<?php

namespace App\Entity;

use App\Enum\CurrencyEnum;
use App\Utils\OperationFactory;
use Doctrine\ORM\Mapping as ORM;

/**
 * Application du taux de cotisation lors du paiement d'une cotisation (au sens TAV).
 * 
 * Au paiement d'une cotisation:
 *      - Un premier Flux est enregistré, correspondant à l'achat/vente d'emlc.
 *      - Puis on applique le taux défini dans le ProfilDeCotisation de l'adhérent,
 *        on crée un nouveau flux pour compléter la cositsation.
 *
 * @ORM\Entity
 */
class TauxCotisationApplication extends Flux
{
    const TYPE_REVERSEMENT_COTISATION_ADHERENT = 'reversement_cotisation_adherent';
    const TYPE_PRELEVEMENT_COTISATION_ADHERENT = 'prelevement_cotisation_adherent';

    /**
     * @return string
     */
    public function getParenttype(): string
    {
        return parent::TYPE_APPLICATION_TAUX_COTISATION;
    }

    public function getAllOperations($em)
    {
        return [];
    }

    public function operate($em)
    {
        return [];
    }

    /**
     * @return string
     */
    public function getType(): string
    {
        return '';
    }

    public function getUsersToNotify()
    {
        return [];
    }
}
